package db

import (
	"context"
	"lmika.dev/lmika/hugo-crm/gen/sqlc/dbq"
	"lmika.dev/lmika/hugo-crm/models"
)

func (db *DB) InsertSite(ctx context.Context, site *models.Site) error {
	id, err := db.q.NewSite(ctx, dbq.NewSiteParams{
		Name:  site.Name,
		Title: site.Title,
		Url:   site.URL,
		Theme: site.Theme,
		Props: []byte("{}"),
	})
	if err != nil {
		return err
	}
	site.ID = id
	return nil
}

func (db *DB) GetSite(ctx context.Context, id int64) (models.Site, error) {
	site, err := db.q.GetSiteWithID(ctx, id)
	if err != nil {
		return models.Site{}, err
	}

	return models.Site{
		ID:    site.ID,
		Name:  site.Name,
		Title: site.Title,
		Theme: site.Theme,
	}, nil
}
